#ifndef HEADER_ENGINE
#define HEADER_ENGINE

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Engine
{
    public:

    Engine();

    void PlayGame();
    void PauseGame();
    void StartGame();
    void StopGame();
    void SetFpsWish(int v);
    void ShowFps();
    void HideFps();
    void RestartGame();
    void AffectScript(Script & VScript);
    void AffectMap(Map * VMap);
    void MoveScreen( int x ,int y);
    void MiddleScreen(int x , int y , bool fixe = true);
    void UpdateRelativePosition();

    void SetType(int v);
    int GetType();


    void CreateTab( int v);
    void AddObject( Object * v);
    void DelObject( Object * v);

    int GetNbObject(){return nbobject;}

    bool WaitOneSecond();

    int Game();

    Object ** ListeObject; // Tableau de pointeur sur Object
    Script * EScript;

    AABB screen;

    Map * gamemap;

    int nbobject;

    private:

    int time;

    bool run;
    bool execute;
    bool fps;
    int fpswish;
    bool restart;
    int type;

};

#endif

