#ifndef HEADER_RIGIBODYS
#define HEADER_RIGIBODYS

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Object;
class Transforms;
class Rigibody;

double min( double A , double B);

int ABS( int v );
int SGN( int v );

struct MassData
{
float mass;
float inv_mass;
};

struct Material
{
float density;
float restitution;
};

struct Body
{
Transforms * transform;
Material material;
MassData mass_data;
Vec2 velocity;
Vec2 acceleration;
Vec2 force;
};

class Rigibody
{
    public:

    Rigibody(Object * Pointeur);

    void AppliedForce();

    Vec2 SommesdesForces();
    void TestCollision(Rigibody * A, Rigibody * B);
    void ResolveCollision( Body & A, Body &B );
    int TryMove( int x , int  y);
    int Move( int  x , int  y);
    int CollisionDecor( int x , int y);

    void Affine(int vx , int vy);

    void UseFixeBody( int w , int h);
    void UseFlexBody();

    void SetMass(float);

    void AddForce(Vec2);
    void AddForce(double,double);

    bool usefixebody;
    int widht , height;

    Object * Conteneur;

    Body R_body;

};


#endif

