#ifndef HEADER_TRANSFORMS
#define HEADER_TRANSFORMS

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Object;

class Transforms
{
    public:

    Transforms(Object * Pointeur);

    Vec2 GetPosition();

    double GetX();
    double GetY();

    double GetReelX();
    double GetReelY();

    double GetRelativeX();
    double GetRelativeY();

    void SetX(double v);
    void SetY(double v);
    void SetXY(double vx ,double vy);
    void SetRelativeXY(double vx ,double vy);
    void SetReelXY(double vx ,double vy);

    private:

    Vec2 positionreel; // en m
    Vec2 positionabsolu; // en pixel
    Vec2 positionrelative; // en pixel

    Object * Conteneur;
};

#endif

