#ifndef HEADER_ANIMATION
#define HEADER_ANIMATION

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Animation
{
    public:

    Animation();
    Animation(Sprite * v , int nb , int nbd = 250, bool vwaitatend = false , bool vwaittheend = false);
    Animation(Sprite & v);

    void DelAnim();
    void SetIte(int v);

    void SetDelay(int v);
    int GetDelay();

    bool GetWaittheEnd();
    bool GetisEnd();

    int GetSizeX();
    int GetSizeY();

    int GetBlitX();
    int GetBlitY();

    void DrawReverseAnim( int , int , int);
    void DrawAnim( int , int , int );

    bool WaitDelay();

    private:

    Sprite * TabSprite;

    int iterateur;
    int delay;  // En ms
    int time;
    int nb_image;

    bool waitatend;
    bool waittheend;
    bool isend;


};

#endif

