#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/input.h"
#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}


Render::Render(Object * Pointeur)
{
    Conteneur = Pointeur;
    this->TabAnim = NULL;
    this->nb_anim = 0;

    this->iterateur = 0;

    this->reverse = false;
    this->direction = 0;

    copie = false;

}

Render::~Render()
{
    if(copie == true)delete TabAnim;
}

void Render::SetRender(Animation * v, int nb)
{
    this->TabAnim = v;
    this->nb_anim = nb;
}

void Render::SetRender(Animation & v)
{
    this->TabAnim = &v;
    this->nb_anim = 1;
}

void Render::CopieRender(Animation * v, int nb)
{
    this->TabAnim = new Animation[nb];

    for(int i = 0; i < nb ; i++)
    {
        TabAnim[i] = v[i];
    }

    this->nb_anim = nb;
    copie = true;
}

void Render::CopieRender(Animation & v)
{
    this->TabAnim = new Animation;

    TabAnim[0] = v;

    this->nb_anim = 1;
    copie = true;
}

bool Render::GetisEnd()
{
    return TabAnim[this->iterateur].GetisEnd();
}

void Render::DelRender()
{
    this->TabAnim = NULL;
}

void Render::ReverseRender(bool v)
{
    this->reverse = v;
}

void Render::SetDirection(int v)
{
    this->direction = v;

    if(direction > 360) direction -= 360;
    if(direction < 0) direction += 360;
}

int Render::GetDirection()
{
    return this->direction;
}

void Render::DrawObject()
{
    if(TabAnim != NULL)
    {

    if( this->iterateur >= this->nb_anim) this->iterateur = 0;

    if(reverse == false)TabAnim[ this->iterateur].DrawAnim( Conteneur->OTransforms->GetRelativeX() , 64 - Conteneur->OTransforms->GetRelativeY() - GetSizeY() , direction);
    else TabAnim[ this->iterateur].DrawReverseAnim( Conteneur->OTransforms->GetRelativeX()  , 64 - Conteneur->OTransforms->GetRelativeY() - GetSizeY() , direction);
    }
}

void Render::SetIt(int v)
{
    if(this->iterateur != v && (TabAnim[this->iterateur].GetWaittheEnd() == false || TabAnim[this->iterateur].GetisEnd() == true) )
    {
        this->iterateur = v;
        TabAnim[ this->iterateur].SetIte(0);
    }
}

bool Render::GetReverse()
{
    return this->reverse;
}

int Render::GetIt()
{
    if(TabAnim != NULL)return this->iterateur;
    else return 0;
}

int Render::GetSizeY()
{
    if(TabAnim != NULL)return this->TabAnim[this->iterateur].GetSizeY();
    else return 0;
}

int Render::GetSizeX()
{
    if(TabAnim != NULL)return this->TabAnim[this->iterateur].GetSizeX();
    else return 0;
}

int Render::GetBlitX()
{
    if(TabAnim != NULL)return this->TabAnim[this->iterateur].GetBlitX();
    else return 0;
}

int Render::GetBlitY()
{
    if(TabAnim != NULL)return this->TabAnim[this->iterateur].GetBlitY();
    else return 0;
}
