#ifndef HEADER_RENDER
#define HEADER_RENDER

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Object;

class Render
{
    public:

    Render(Object * Pointeur);
    ~Render();

    void SetRender(Animation * v, int nb);
    void SetRender(Animation & v);

    void CopieRender(Animation * v, int nb);
    void CopieRender(Animation & v);

    void DelRender();

    void SetIt( int v);
    int GetIt();


    bool GetisEnd();

    void ReverseRender(bool);
    bool GetReverse();

    void SetDirection(int);
    int GetDirection();

    int GetSizeY();
    int GetSizeX();

    int GetBlitX();
    int GetBlitY();

    void DrawObject();

    private:

    Object * Conteneur;
    Animation * TabAnim;

    int nb_anim;
    int iterateur;
    int time;
    bool reverse;
    int direction;
    bool copie;

};


#endif

