#ifndef HEADER_TILESMAPING
#define HEADER_TILESMAPING

#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"


extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}

class Engine;

struct Vec2
{
    double x;
    double y;

    friend Vec2 operator+ ( Vec2 , Vec2);
    friend Vec2 operator- ( Vec2 , Vec2);
    friend Vec2 operator* (Vec2 A , double B);

};
struct AABB
{
  Vec2 min;
  Vec2 max;
  friend AABB operator+ ( AABB , Vec2);

};




class Map
{
    public:

    void SetMap( const unsigned char * Tile , const unsigned char ** yourmap , bool * properties, int taillextile , int tailleytile , int largeurmonde , int heuteurmonde);
    void SetMap( const unsigned char * Tile , unsigned char ** yourmap , bool * properties, int taillextile , int tailleytile , int largeurmonde , int heuteurmonde);
    void AfficherMap();
    void MoveMap();
    void UpdateScroll();
    void ClampScroll();

    void AffectEngine( Engine * V);

    Map();

	const unsigned char * Tileset;
	unsigned char ** map;
	bool * plein;
	int * precis;

	Engine * EConteneur;

	int LARGEUR_TILE,HAUTEUR_TILE,LARGEUR_DECALAGE_TILE;

	int nbtiles_largeur_monde,nbtiles_hauteur_monde;
	int xscroll,yscroll;
	int largeur_fenetre,hauteur_fenetre;
};


#endif

